SystemOrganization addCategory: #'Oth-chat'!

Object subclass: #Messenger
	instanceVariableNames: 'window container r socket'
	classVariableNames: 'buttonMorph chatMorph cl'
	poolDictionaries: ''
	category: 'Oth-chat'!

Messenger class
	instanceVariableNames: 'messgr'!

!Messenger commentStamp: '<historical>' prior: 0!
A Messenger is chat client.

Instance Variables
	buttonMorph:		<Object>
	chatMorph:		<Object>
	cl:		<Object>
	container:		<Object>
	controller:		<Object>
	handler:		<Object>
	r:		<Object>
	socket:		<Object>
	window:		<Object>
	ws:		<Object>

buttonMorph
	- xxxxx

chatMorph
	- xxxxx

cl
	- xxxxx

container
	- xxxxx

controller
	- xxxxx

handler
	- xxxxx

r
	- xxxxx

socket
	- xxxxx

window
	- xxxxx

ws
	- xxxxx
!

Messenger class
	instanceVariableNames: 'messgr'!

Messenger subclass: #ClientClass
	instanceVariableNames: 'ws interactionStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oth-chat'!

!ClientClass commentStamp: '<historical>' prior: 0!
A ClientClass is client side code.
!

!ClientClass methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/29/2014 02:14'!
connect

	| msgLoop hostname data chunk |
	
	socket := Socket newTCP.
	hostname:= 'localhost'.
	socket connectTo: (NetNameResolver addressForName: hostname) port: (8888) waitForConnectionFor: 10.
	interactionStream := SocketStream on: socket.
	Transcript open.
	Transcript show: 'Client side'.


	msgLoop := [ 
		
		data := 'begin'.
    	[data ~= 'quit'] whileTrue: [
	
	[interactionStream isDataAvailable] whileTrue: [
	chunk := interactionStream nextAllInBuffer.
	(chunk isMemberOf: Array)ifTrue:[
	super updateLog: 'hi'.
	chunk crLog.].
		].
	data := socket receiveData.
			('Client: ', data) crLog
			].
			interactionStream close.
		socket sendData: 'quit'.
		data := socket receiveDataTimeout: 0.
		data crLog.
	
		'DONE' crLog.
		socket closeAndDestroy.
		socket := nil.
	] newProcess.

	msgLoop name: 'Othello Client Process'.
	msgLoop resume.! !

!ClientClass methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/29/2014 01:25'!
initialize
super initialize.
ws :=  (ReadWriteStream on: String new). 
^ self.
! !

!ClientClass methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/29/2014 00:25'!
rwStream
^ ws.! !

!ClientClass methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/29/2014 01:01'!
sendData: aString
	(socket ~= nil)
	ifTrue: [
				interactionStream sendCommand: aString.
		interactionStream nextLine crLog. 
		interactionStream flush.
						socket closeAndDestroy.
		
interactionStream ifNotNil: [interactionStream close]
] fork.
	! !

!Messenger class methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/29/2014 01:26'!
client
cl := ClientClass new.
cl connect.! !

!Messenger class methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/29/2014 01:26'!
server
cl := ServerClass new.
cl listen.
! !

!Messenger methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/29/2014 00:42'!
handler
| newString |
(r contents asString  = '') ifTrue:[^ true].
newString:= ((r contents) asString).
r contents: '                                                       '.
self updateLog: (newString).
cl sendData: (newString).
! !

!Messenger methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/29/2014 00:23'!
initialize
super initialize.
chatMorph := TextMorph new.
buttonMorph := SimpleButtonMorph new.
r := TextMorph new.
chatMorph backgroundColor: Color lightYellow .

  r backgroundColor: Color white.
  chatMorph bounds: ((0@0) corner:(70@30)). 
r bounds: ((4@400.0) corner: (221.0@636.0)).
buttonMorph bounds: ((222@400.0) corner: (261.0@433.0)).
       buttonMorph target: self;
                actionSelector: #handler.
buttonMorph label: 'Send'.
	window := StandardWindow labelled: 'Chat client'.
	window addMorph:  (container := chatMorph) frame: (0@0 corner: 650@650).
	window addMorph: r.
	window addMorph: buttonMorph.
	window bounds: ((579.0@ -1.0) corner: (1279.0@499.0)).
	window openInWorld.
! !

!Messenger methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/29/2014 00:25'!
rwStream
^ self subclassResponsibility.! !

!Messenger methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/28/2014 16:38'!
sendData: aStream
^ self subclassResponsibility.! !

!Messenger methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/29/2014 00:42'!
updateLog: aString
(cl rwStream) nextPutAll: 'Prashant says:', aString; cr.    
 chatMorph contents: ((cl rwStream) contents).  ! !

Messenger subclass: #ServerClass
	instanceVariableNames: 'interactionStream ws'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oth-chat'!

!ServerClass commentStamp: '<historical>' prior: 0!
A ServerClass is server side code.

Instance Variables
	interactionStream:		<Object>

interactionStream
	- xxxxx
!

!ServerClass methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/29/2014 01:25'!
initialize
super initialize.
ws :=  (ReadWriteStream on: String new). 
^ self.
! !

!ServerClass methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/29/2014 02:14'!
listen

	| connection msgLoop data|
	
	
	msgLoop := [
		connection := Socket newTCP.
		connection listenOn: (8888) backlogSize: 100.
		Transcript open.
		Transcript show: 'Server side'.
		socket := connection waitForAcceptFor: 30.
		connection closeAndDestroy.

		interactionStream := SocketStream on: socket.

		data := 'begin'. "initialized to enter loop"
		
		[ data~= 'quit' ] whileTrue:[
		] fork.		


			

	] fork.

	msgLoop name: 'Othello Server Process'.
	msgLoop resume.

	"TODO: remove
	(Delay forSeconds: 2) wait.
	ClientController new connect: 'localhost'.
	"! !

!ServerClass methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/29/2014 00:25'!
rwStream
^ ws.! !

!ServerClass methodsFor: 'as yet unclassified' stamp: 'PrashantRavi 7/29/2014 02:12'!
sendData: aString
|rt|.
	(socket ~= nil)
	ifTrue: [
		rt := Array with:'hi prashant' .
				interactionStream sendCommand: rt.
		interactionStream nextLine crLog. 
		interactionStream flush.
						socket closeAndDestroy.
		
interactionStream ifNotNil: [interactionStream close]
] fork.
	
! !
